const fs = require('fs');

module.exports = function (filename, newVersion, then) {
    var lineReader = require('readline').createInterface({
        input: fs.createReadStream(filename)
    });

    var versionFound = false;
    var result = '';

    lineReader.on("line", (ln) => {
        if (ln.toString().indexOf('<Version>') >= 0) {
            // don't need a xml parser or whatever to be able to change versions
            result += ln.substring(0, ln.indexOf('<')) + `<Version>${newVersion}</Version>\n`; // I use substring to get tabulation
            versionFound = true;
        }
        else {
            result += ln + "\n";
        }
    });
    lineReader.on("close", () => {
        if (!versionFound) {
            then("version tag not found. Ensure your csproj contains a Version tag inside a PropertyGroup");
        }
        else {
            fs.writeFile(filename, result, () => then());
        }
    });
};