const p = require('child_process');
const path = require('path')
const fs = require("fs")
module.exports = {
    run: async (cmd)=> {
        var child = p.exec(cmd, { env: process.env });
        child.stdout.pipe(process.stdout);
        child.stderr.pipe(process.stderr);
        return new Promise((ff, rej) =>
            child
                .on('close', () => ff())
                .on('error', (err) => rej(err))
                .on('exit', (exitCode) => {
                    if (exitCode != 0) rej(`error running ${cmd}. Exit code: ${exitCode}`);
                })
        );
    },
    question: async (rl, questionString) => new Promise((ff, rej)=> rl.question(questionString, answer => ff(answer)))
}

fs_sync = {
    writeAsync: async (f, chunk)=> new Promise((ff, rej)=>f.write(chunk, (err) => err?rej(err) : ff()))
}
config = {
    save: async (filename, obj)=>{
        var f = fs.createWriteStream(filename, 'utf-8', 'w');
        await fs_sync.writeAsync(f, JSON.stringify(obj, null, 4));
        f.close();
    },

    load: async (filename) => {
        return new Promise((ff, rj)=>{
            console.log(`opening file ${filename}`)
            var file = fs.createReadStream(filename);
            var data = fs.readFileSync(filename, 'utf-8');
            return ff(JSON.parse(data));
            file.on("data", (chunk)=> {
                console.log('received chunk')
                data += chunk.toString();
            });
            file.on("close", ()=> {

                file.close();
                console.log(data)
                ff(JSON.parse(data));
            });
        })
    }
}

module.exports.fs_sync = fs_sync;
module.exports.config = config;