const readline = require("readline");
const fs = require('fs');
const path = require('path');
const localPath = path.join(process.cwd(), 'node_modules', 'nuance-gulp-build');
const common = require('../../common')

dotnet_profiles = {
    "vs2017": {
        build_mode: 'dotnet',
        pack_mode: 'dotnet',
        bump_type: 'csproj17'
    }
}

module.exports = {
    rm: async (args)=>{
        config = getConfig();
        delete config["buildProjects"][args.name];
        await common.config.save('.buildconfig.json', config);
    },

    add: async (args)=>{

        const profile = dotnet_profiles[args.profile] || {}
        const rl = readline.createInterface({ input: process.stdin, output: process.stdout });
        var p = {
            build: args.skip_build ? false : true,
            build_mode : args.build_mode || profile.build_mode,
            pack_mode: args.pack_mode || profile.pack_mode,
            pack_options: {
                output: args.package_output || 'packages'
            },
            bump_type: args.bump_type || profile.bump_type,
            publisher : args.publisher || 'nuget',
            source_path: ''
        }
        var filename = path.join(process.cwd(), '.buildconfig.json');
        config = common.config.load(filename);
    
        var name = args.name || await common.question(rl, "Project name: ");
        p.build_mode = p.build_mode || await common.question(rl, "build mode? (msbuild|dotnet): ") || "dotnet"
        p.pack_mode = p.pack_mode || await common.question(rl, "pack mode? (nuget|dotnet): ") || "dotnet"
        p.source_path = args.project_path || await common.question(rl, "project location (relative to git root): ")
        p.bump_type = p.bump_type || await common.question(rl, "version location (csproj17|project_json): ")
        config.buildProjects = config.buildProjects || {};
        config.buildProjects[name] = p;
        if(!fs.existsSync(p.source_path)){
            throw `project file ${p.source_path} does not exist`;
        }

        await common.config.save(filename, config);
        
        rl.close();
    }
}